unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolWin, ComCtrls, ExtCtrls, Buttons, StdCtrls, FileCtrl, ImgList, jpeg, IniFiles,
  Menus, ExtDlgs;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel3: TPanel;
    Splitter2: TSplitter;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FilterComboBox1: TFilterComboBox;
    FileListBox1: TFileListBox;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
		ToolButton2: TToolButton;
		ToolButton3: TToolButton;
		PopupMenu1: TPopupMenu;
		NewKedvenc: TMenuItem;
		N1: TMenuItem;
    ToolButton4: TToolButton;
    UpDown1: TUpDown;
    ToolButton5: TToolButton;
    Timer1: TTimer;
    PopupMenu2: TPopupMenu;
    FileDelete: TMenuItem;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    PopupMenu3: TPopupMenu;
    ColorOk: TMenuItem;
    Color2: TMenuItem;
    Color16: TMenuItem;
    Color256: TMenuItem;
    Color16M: TMenuItem;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolBar2: TToolBar;
    Panel6: TPanel;
    Edit2: TEdit;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton12: TToolButton;
    ToolButton8: TToolButton;
    Panel5: TPanel;
    ToolButton16: TToolButton;
    Panel7: TPanel;
    Label2: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    ComboBox1: TComboBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    SavePictureDialog1: TSavePictureDialog;
		procedure FormCreate(Sender: TObject);
		procedure ToolButton1Click(Sender: TObject);
		procedure FileListBox1Click(Sender: TObject);
		procedure FormClose(Sender: TObject; var Action: TCloseAction);
		procedure ToolButton3Click(Sender: TObject);
		procedure NewKedvencClick(Sender: TObject);
		procedure KedvencClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FileDeleteClick(Sender: TObject);
    procedure ToolButton13Click(Sender: TObject);
    procedure ColorOkClick(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton9DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ToolButton9DragDrop(Sender, Source: TObject; X, Y: Integer);
	private
		{ Private declarations }
		FileName: string;
    DeleteConfirm: Boolean;
		procedure FileOpen(PictureName: string);
		procedure StatusBar(Sender: TObject);
		procedure PictureStretch;
		procedure RefreshImage;
		procedure AddKedvenc(s: string);
    procedure SaveAsHint;
    procedure Save(SourceFileName, DestFileName: string; Modi: Boolean);
	public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function GyorsitoLe(s: string): string;
var i: integer;
begin
	result:=s;
	i:=Pos('&',s);
	if i>0 then
		result:=Copy(s,1,i-1)+Copy(s,i+1,Length(s));
end;


function GetExt(s: string): string;
begin
	// Visszaadja a fjl kiterjesztst!
	result:=Uppercase(ExtractFileExt(s));
end;  


procedure TForm1.FormCreate(Sender: TObject);
var Ini: TIniFile;
		sz: string;
		db,i: integer;
begin
  DeleteConfirm:=False;				// Fjl trlsre rkrdezzen e ?
	FileName:='';
	FileListBox1.Mask:=FilterComboBox1.Mask;
  // Belltsok visszatltse
  Ini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  // Ablak poziciojnak visszatltse
  Left:=Ini.ReadInteger('Form','Left',Left);
  Top:=Ini.ReadInteger('Form','Top',Top);
  Width:=Ini.ReadInteger('Form','Width',Width);
  Height:=Ini.ReadInteger('Form','Height',Height);
  WindowState:=TWindowState(Ini.ReadInteger('Form','State',ord(WindowState)));

  // Az utoljra hasznlt alknyvtr!!!
  DriveComboBox1.Drive:=Char(Ini.ReadInteger('Path','DriveComboBox1',ord(DriveComboBox1.Drive)));
  sz:=Ini.ReadString('Path','DirectoryListBox1',DirectoryListBox1.Directory);
  if DirectoryExists(sz) then
	  DirectoryListBox1.Directory:=sz;

  // Kp kicsinyts visszatltse
	ToolButton3.Down:=Ini.ReadBool('Params','ToolButton3',ToolButton3.Down);

  // Kedvencek betltse!!!
	db:=Ini.ReadInteger('Kedvenc','Count',0);
	for i:=0 to db-1 do
		begin
		sz:=Ini.ReadString('Kedvenc','Kedvenc'+IntToStr(i),'');
		if sz<>'' then
			AddKedvenc(sz);
		end;
  // Bemutat rtkeinek betltse  
	Timer1.Interval:=Ini.ReadInteger('Timer','Interval',Timer1.Interval);
	UpDown1.Position:=Ini.ReadInteger('UpDown','Position',UpDown1.Position);

	// SaveAs paramtereinek elmentse
	SavePictureDialog1.InitialDir:=Ini.ReadString('Form1','SavePictureDialog1',SavePictureDialog1.InitialDir);
	ToolButton13.Down:=Ini.ReadBool('Form','ToolButton13',ToolButton13.Down);
	Edit2.Text:=Ini.ReadString('Form','Edit2',Edit2.Text);
	Edit4.Text:=Ini.ReadString('Form','Edit4',Edit4.Text);
	Edit5.Text:=Ini.ReadString('Form','Edit5',Edit5.Text);
	CheckBox1.Checked:=Ini.ReadBool('Form','CheckBox1',CheckBox1.Checked);
	CheckBox2.Checked:=Ini.ReadBool('Form','CheckBox2',CheckBox2.Checked);
	ComboBox1.ItemIndex:=Ini.ReadInteger('Form','ComboBox1',0);
	Ini.Free;
	ToolButton13Click(nil);			// Bekapcsols!!
	SaveAsHint;						// Ments msknt HINT-jnek belltsa
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
	Close;
end;


procedure TForm1.PictureStretch;
var R: TRect;
		w,h: double;
begin
			// Kp ablak mrethez van igaztva!!!
			if (ToolButton3.Down) and (FileName<>'') then
				begin
				// R:=ScrollBox1.ClientRect;			// Megnzzk, hogy nem nylik e valamelyik oldal ki!!!
				Image1.Align:=alNone;
				R:=Rect(0,0,ScrollBox1.Width-4,ScrollBox1.Height-4);
				if (Image1.Picture.Width>R.Right) or (Image1.Picture.Height>R.Bottom) then
					begin
					w:=Image1.Picture.Width/R.Right;		// A szlessg arnya!!
					h:=Image1.Picture.Height/R.Bottom;	// A magassg arnya!!
					// A nagyobb arnnyal kell tmretezni az ablakot!
					if h>w then
						w:=h;
					// Arnyok tlltsa
					ScrollBox1.HorzScrollBar.Range:=round(Image1.Picture.Width/w);
					Image1.Width:=ScrollBox1.HorzScrollBar.Range;
					ScrollBox1.VertScrollBar.Range:=round(Image1.Picture.Height/w);
					Image1.Height:=ScrollBox1.VertScrollBar.Range;
					Image1.Stretch:=True;
					end
				else
					begin
					Image1.Width:=Image1.Picture.Width;
					Image1.Height:=Image1.Picture.Height;
					end;
				// Rakjuk az ablak kzepre a kpet!!!
				Image1.Left:=(R.Right-Image1.Width) div 2;
				Image1.Top:=(R.Bottom-Image1.Height) div 2;
				end;
end;


procedure TForm1.FileOpen(PictureName: string);
// var s: string;
begin
		if Uppercase(FileName)=Uppercase(PictureName) then		// Mr be van tltve, nem kell!!
			exit;
		// s:=GetExt(PictureName);
		try
		FileName:=PictureName;
		if FileExists(FileName) then
			begin
      Image1.Stretch:=ToolButton3.Down;
			Image1.Align:=alNone;
			Screen.Cursor:=crHourGlass;
			Image1.Picture.LoadFromFile(FileName);
			// lltsuk be a mreteket
			ScrollBox1.HorzScrollBar.Position:=0;
			ScrollBox1.HorzScrollBar.Range:=Image1.Picture.Width;
			ScrollBox1.VertScrollBar.Position:=0;
			ScrollBox1.VertScrollBar.Range:=Image1.Picture.Height;
			Image1.Align:=alClient;

			// Kp ablak mrethez van igaztva!!!
			if ToolButton3.Down then
				PictureStretch;
        
			StatusBar(nil);
			end;
		except
		end;
		Screen.Cursor:=crDefault;
end;

procedure TForm1.StatusBar(Sender: TObject);
begin
	StatusBar1.Panels.BeginUpdate;
  if Image1.Picture.Graphic.Empty then
		StatusBar1.Panels[0].Text:=''
	else
		begin
		StatusBar1.Panels[0].Text:='Mret: '+IntToStr(Image1.Picture.Width)+' x '+IntToStr(Image1.Picture.Height);
		// StatusBar1.Panels[3].Text:='Kp: '+IntToStr(SpinEdit1.Value)+' x '+IntToStr(Image1.Picture.Width div SpinEdit1.Value)+' x '+IntToStr(Image1.Picture.Height);
		end;
	StatusBar1.Panels[4].Text:=FileName;
	StatusBar1.Panels.EndUpdate;
end;


procedure TForm1.FileListBox1Click(Sender: TObject);
begin
	if FileListBox1.ItemIndex>-1 then
		FileOpen(FileListBox1.Directory+'\'+FileListBox1.Items[FileListBox1.ItemIndex]);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var Ini: TIniFile;
		i: integer;
		sz: string;
begin
  Ini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  // Ablak poziciojnak visszatltse
  Ini.WriteInteger('Form','State',ord(WindowState));
  WindowState:=wsNormal;
  Ini.WriteInteger('Form','Left',Left);
  Ini.WriteInteger('Form','Top',Top);
  Ini.WriteInteger('Form','Width',Width);
  Ini.WriteInteger('Form','Height',Height);
  
  // Az utoljra hasznlt alknyvtr mentse
	Ini.WriteInteger('Path','DriveComboBox1',ord(DriveComboBox1.Drive));
	Ini.WriteString('Path','DirectoryListBox1',DirectoryListBox1.Directory);

  // Kp kicsinyts elmentse
  Ini.WriteBool('Params','ToolButton3',ToolButton3.Down);

	// Kedvencek elmentse
	Ini.WriteInteger('Kedvenc','Count',PopupMenu1.Items.Count-2);
	for i:=2 to PopupMenu1.Items.Count-1 do
		begin
		sz:=GyorsitoLe(PopupMenu1.Items[i].Caption);
		Ini.WriteString('Kedvenc','Kedvenc'+IntToStr(i-2),sz);
		end;
  // Bemutat paramtereinek mentse
	Ini.WriteInteger('Timer','Interval',Timer1.Interval);
	Ini.WriteInteger('UpDown','Position',UpDown1.Position);

	// SaveAs paramtereinek elmentse
	Ini.WriteString('Form1','SavePictureDialog1',SavePictureDialog1.InitialDir);
	Ini.WriteBool('Form','ToolButton13',ToolButton13.Down);
	Ini.WriteString('Form','Edit2',Edit2.Text);
	Ini.WriteString('Form','Edit4',Edit4.Text);
	Ini.WriteString('Form','Edit5',Edit5.Text);
	Ini.WriteBool('Form','CheckBox1',CheckBox1.Checked);
	Ini.WriteBool('Form','CheckBox2',CheckBox2.Checked);
	Ini.WriteInteger('Form','ComboBox1',0);

  Ini.Free;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
	// Fel kell frissteni a kpet!!
  RefreshImage;
end;

procedure TForm1.RefreshImage;
var s: string;
begin
	if FileName<>'' then
  	begin
    s:=FileName;
    FileName:='';
		FileOpen(s);
		end;
end;


procedure TForm1.KedvencClick(Sender: TObject);
var s: string;
begin
	// Kedvenc kivlasztsa
  s:=GyorsitoLe(TMenuItem(Sender).Caption);
  if DirectoryExists(s) then
	  DirectoryListBox1.Directory:=s;
end;


procedure TForm1.AddKedvenc(s: string);
var TM: TMenuItem;
		sz,z: string;
		i: integer;
begin
	// Megnzzk, hogy nincs e mg ilyen kedvenc
	z:=Uppercase(s);				// Csupa nagybet!
	for i:=2 to PopupMenu1.Items.Count-1 do
		begin
		sz:=Uppercase(GyorsitoLe(PopupMenu1.Items[i].Caption));
		if z=sz then					// Mr van ilyen, nem szabad hozzadni!!!
			exit;
		end;
	// Hozzads a kedvencekhez!!!
	TM:=TMenuItem.Create(Self);
	TM.Caption:=s;
	TM.OnClick:=KedvencClick;
	PopupMenu1.Items.Add(TM);
end;



procedure TForm1.NewKedvencClick(Sender: TObject);
begin
	// Hozzads a kedvencekhez!!!
  AddKedvenc(DirectoryListBox1.Directory);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var TB: TSpeedbutton;
		P: TPoint;
begin
	// A popupmenu1 (Kedvencek) meghvsa
	TB:=TSpeedbutton(Sender);
	P:=Point(TB.Left,TB.Top+TB.Height);
	P:=TB.ClientToScreen(P);
	PopupMenu1.Popup(P.X,P.Y);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
	// Kp lptets
	Timer1.Enabled:=False;
	if FileListBox1.ItemIndex+1>=FileListBox1.Items.Count then
		begin
		// Timert le kell lltani, s megsznettni a lejtszst!!!
		ToolButton4.Down:=False;
		exit;
		end;
	// Lptets!
  FileListBox1.Selected[FileListBox1.ItemIndex]:=False;		// Jel kivtele
  FileListBox1.Selected[FileListBox1.ItemIndex+1]:=True;  // Jel beraksa az jba!
	// FileListBox1.ItemIndex:=FileListBox1.ItemIndex+1;
	FileListBox1Click(nil);								// j fjl megjelentse
	Timer1.Enabled:=True;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
	Timer1.Enabled:=ToolButton4.Down;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
	// Id lptetse fel-le a bemutathoz!!!
	if Button=btNext then
		Timer1.Interval:=Timer1.Interval-100
	else
		Timer1.Interval:=Timer1.Interval+100;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
	// Lejtszs kikapcsolsa az ESC letsre!
	if (Key=#27) and (ToolButton4.Down) then
		begin
		Key:=#0;
		Timer1.Enabled:=False;
		ToolButton4.Down:=False;
		end;
end;

procedure TForm1.FileDeleteClick(Sender: TObject);
var i: integer;
begin
	// Kivlasztott fjl trlse!!!!
	if FileListBox1.ItemIndex>-1 then		// Van kijellt fjl!!!
		begin
		if (not DeleteConfirm) or (MessageDlg('Fjl trls:'+#13+FileListBox1.FileName+#13+'Biztosan trljem?',
		mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
			begin
			i:=FileListBox1.ItemIndex;
			if DeleteFile(FileListBox1.FileName) then
				begin
				FileListBox1.Items.Delete(i);
				if i=FileListBox1.Items.Count then
					i:=FileListBox1.Items.Count-1;
        if i>-1 then
          FileListBox1.Selected[i]:=True;
				// Megjelents
				FileListBox1Click(nil);
				end;
			end;
		end;
end;

procedure TForm1.ToolButton13Click(Sender: TObject);
begin
	// Ments msknt paramtereinek belltsa
	ToolBar2.Visible:=ToolButton13.Down;
end;

procedure TForm1.ColorOkClick(Sender: TObject);
var TM: TMenuItem;
		i: integer;
		s: string;
begin
	// Rgi elem trlse
	for i:=0 to PopupMenu3.Items.Count-1 do
		PopupMenu3.Items[i].Checked:=False;
	// Kivlaszts
	TM:=TMenuItem(Sender);
	TM.Checked:=True;
	ToolButton12.ImageIndex:=TM.ImageIndex;
	ToolButton12.Tag:=TM.Tag;
	s:=TM.Caption;
	i:=Pos('&',s);
	if i>-1 then
		s:=Copy(s,1,i-1)+Copy(s,i+1,255);
	ToolButton12.Hint:='Sznmlysg: '+s;						// A megfelel szveget rja ki!!
	SaveAsHint;
end;

procedure TForm1.SaveAsHint;
var s: string;
begin
	// Ments msknt csoport hintjnek belltsa!!
	s:='Ments msknt';
	s:=s+#13+'Alknyvr: '+Edit2.Text;
	s:=s+#13+ToolButton12.Hint;						// Sznmlysg!
	if CheckBox2.Checked then							// Mret!
		s:=s+#13+'Mret: '+Edit4.Text+' x '+Edit5.Text;
	if CheckBox1.Checked then							// Kiterjeszts!!
		s:=s+#13+'Kiterjeszts: '+ComboBox1.Items[ComboBox1.ItemIndex];
	ToolButton10.Hint:=s;
	// SAVE GOMB HINTJNEK BELLTSA
	if SavePictureDialog1.InitialDir<>'' then
		ToolButton9.Hint:='Ments - '+SavePictureDialog1.InitialDir
	else
		ToolButton9.Hint:='Ments';
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
	SaveAsHint;
end;


Procedure FileCopy( Const sourcefilename, targetfilename: String );
Var
	S, T: TFileStream;
Begin
	S := TFileStream.Create( sourcefilename, fmOpenRead or fmShareDenyNone);
	try
		T := TFileStream.Create( targetfilename, fmOpenWrite or fmCreate );
		try
			T.CopyFrom(S, S.Size ) ;
		finally
			T.Free;
		end;
	finally
		S.Free;
	end;
End;


procedure TForm1.Save(SourceFileName, DestFileName: string; Modi: Boolean);
var S_Ext, D_Ext: string;
begin
	// Ments vgrehajtsa
	s_Ext:=UpperCase(ExtractFileExt(SourceFileName));			// Kiterjesztsek leszedse
	d_Ext:=UpperCase(ExtractFileExt(DestFileName));
	if not Modi then			// Sima ments kell!!
		begin
		if s_Ext=d_ext then			// Sima msols
			FileCopy(SourceFileName,DestFileName);
		end;
end;


procedure TForm1.ToolButton9Click(Sender: TObject);
begin
	if FileListBox1.ItemIndex>-1 then
		begin
		SavePictureDialog1.FileName:=ExtractFileName(FileListBox1.FileName);			// Adjuk t a fjl nevt!
		if SavePictureDialog1.Execute then
			begin
			SavePictureDialog1.InitialDir:=ExtractFilePath(SavePictureDialog1.FileName);
			SaveAsHint;						// Ments Hintjnek belltsa
			Save(FileListBox1.FileName,SavePictureDialog1.FileName,False);
			end;
		end;
end;

procedure TForm1.ToolButton9DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
	Accept:=(Source=FileListBox1);
end;

procedure TForm1.ToolButton9DragDrop(Sender, Source: TObject; X,
	Y: Integer);
var s: string;
		i: integer;	
begin
	if (Source=FileListBox1) and (SavePictureDialog1.InitialDir<>'')
		and (SavePictureDialog1.InitialDir<>DirectoryListBox1.Directory)then
		begin
		Screen.Cursor:=crHourglass;
		for i:=0 to FileListBox1.Items.Count-1 do
			begin
			if FileListBox1.Selected[i] then			// Ki van vlasztva, msolni kell!!
				begin
				// Cl nevnek ellltsa
				s:=SavePictureDialog1.InitialDir+'\'+ExtractFileName(FileListBox1.Items[i]);
				// Tnyleges ments!!
				Save(DirectoryListBox1.Directory+'\'+FileListBox1.Items[i],s,False);
				end;
			end;
		Screen.Cursor:=crDefault;
		end;
end;

end.
